package jossihawk;

import jossihawk.simulator.sim.MOEASimulationState;
import jossihawk.simulator.sim.SimulatorController;
import jossihawk.simulator.sim.playback.SimulationPlayback;
import jossihawk.simulator.sim.playback.SimulationRecordingKeeper;

import javax.xml.bind.JAXBException;
import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

/**
 * Created by josteias on 08.06.2016.
 */
public class ScenarioDisplayer {

    public static void main(String[] args) {
        File experimentFolder = new File(SimulationRecordingKeeper.replayFolder);

        File[] filesList = experimentFolder.listFiles();

        System.out.println("Please choose a experiment index");
        for (int i = 0; i < filesList.length; i++) {
            System.out.print(i);
            System.out.println(":\t " + filesList[i].getName());
        }
        Scanner scanner = new Scanner(System.in);
        System.out.print("Enter experiment index: ");

        // get their input as a String
        int index = Integer.parseInt(scanner.next());

        try {
            SimulationPlayback chosenPlayback = SimulationPlayback.readFromFile(new File(filesList[index], "playback.xml"));
            playBack(chosenPlayback);

        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (JAXBException e) {
            e.printStackTrace();
        }
    }

    private static void playBack(SimulationPlayback chosenPlayback) throws JAXBException {
        MOEASimulationState initialState = chosenPlayback.getStates().get(0);
        SimulatorController controller = new SimulatorController(initialState.getState());
        controller.setAsMainSimulator(false);
        controller.reinitializeFromState(initialState.getState());
    }
}
