package jossihawk.ep;

import jossihawk.simulator.SimulationState;
import org.moeaframework.core.Solution;

public class AIMSpeedVectorProblem extends AIMProblem {

    public AIMSpeedVectorProblem(SimulationState simulationState, double maxKineticEnergy, double maxDistanceTravelled, double bestTinyThroughput, double worstStarvation) {
        super(simulationState, simulationState.getSimulationProperties().getNumberOfCars(), simulationState.getSimulationProperties().getNumberOfObjectives(), 1, maxKineticEnergy, maxDistanceTravelled, bestTinyThroughput, worstStarvation);
    }

    @Override
    public Solution newSolution() {
        Solution solution = new Solution(getNumberOfVariables(), getNumberOfObjectives(), getNumberOfConstraints());
        for (int i = 0; i < getNumberOfVariables(); i++) {
            SpeedVectorVariable var = new SpeedVectorVariable(0, getSimulationProperties().getSpeedLimit());
            solution.setVariable(i, var);
        }
        return solution;
    }

}
