package jossihawk.ep;

import org.moeaframework.core.Solution;
import org.moeaframework.core.variable.EncodingUtils;

public class ChosenIndividual {
    private final Solution chosenSolution;

    private final double singleObjectiveValue;

    public ChosenIndividual(Solution chosenSolution, double singleObjectiveValue) {
        this.chosenSolution = chosenSolution;
        this.singleObjectiveValue = singleObjectiveValue;
    }

    public double[] getSpeeds() {
        //If there are no cars, return empty array. This makes sure step() does nothing.
        if(chosenSolution == null) {
            return new double[0];
        }
        return EncodingUtils.getReal(chosenSolution);
    }

    public Solution getChosenSolution() {
        return chosenSolution;
    }

    public double getSingleObjectiveValue() {
        return singleObjectiveValue;
    }
}
