package jossihawk.ep;

import org.moeaframework.core.PRNG;
import org.moeaframework.core.variable.RealVariable;

public class SpeedVectorVariable extends RealVariable {

    public SpeedVectorVariable(double min, double max){
        super(min,max);
    }

    public SpeedVectorVariable(double speed, double min, double max) {
        super(speed,min,max);
    }

    public void setSpeed(double speed) {
        this.setValue(speed);
    }

    public double getSpeed() {
        return getValue();
    }

    @Override
    public RealVariable copy() {
        return new SpeedVectorVariable(getValue(), getLowerBound(), getUpperBound());
    }

    @Override
    public void randomize() {
        setValue(PRNG.nextDouble(getLowerBound(), getUpperBound()));
    }
}
