package jossihawk.simulator;

import jossihawk.simulator.sim.VehicleState;

import javax.xml.bind.annotation.XmlRootElement;
import java.util.Set;


@XmlRootElement
public class SimulationState {


    private Set<VehicleState> vehicleStates;
    private SimulationProperties simulationProperties;

    public SimulationState(){}

    public SimulationState(Set<VehicleState> vehicleStates, SimulationProperties simulationProperties) {
        this.vehicleStates = vehicleStates;
        this.simulationProperties = simulationProperties;
    }

    public void setVehicleStates(Set<VehicleState> vehicleStates) {
        this.vehicleStates = vehicleStates;
    }

    public void setSimulationProperties(SimulationProperties simulationProperties) {
        this.simulationProperties = simulationProperties;
    }

    public Set<VehicleState> getVehicleStates() {
        return vehicleStates;
    }

    public SimulationProperties getSimulationProperties() {
        return simulationProperties;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof SimulationState)) return false;

        SimulationState that = (SimulationState) o;

        if (getVehicleStates() != null ? !getVehicleStates().equals(that.getVehicleStates()) : that.getVehicleStates() != null)
            return false;
        return !(getSimulationProperties() != null ? !getSimulationProperties().equals(that.getSimulationProperties()) : that.getSimulationProperties() != null);

    }

    @Override
    public int hashCode() {
        int result = getVehicleStates() != null ? getVehicleStates().hashCode() : 0;
        result = 31 * result + (getSimulationProperties() != null ? getSimulationProperties().hashCode() : 0);
        return result;
    }
}
