package jossihawk.simulator;


public class TestSimulatorImpl extends AIMSimulator {

    private double[] objectives;
    private SimulationProperties simulationProperties;

    public TestSimulatorImpl(SimulationProperties simulationProperties) {
        this.simulationProperties = simulationProperties;
        objectives = new double[simulationProperties.getNumberOfObjectives()];
    }

    /**
     * Setup the simulation environment, then calculate the objective scores for the solution.
     * @param speeds The speeds that should be evaluated.
     */
    @Override
    public void evaluate(double[] speeds) {
        int i = 0;
        if(simulationProperties.getEvaluateCollisions()) {
            objectives[i] = evaluateThroughput(speeds);
            i++;
        }

        if(simulationProperties.getEvaluateThroughput()) {
            objectives[i] = evaluateCollisions(speeds);
            i++;
        }
    }

    @Override
    public AIMStats getTotalStats() {
        return null;
    }

    @Override
    public int getNumberOfCollisions() {
        return (int) objectives[0];
    }

    @Override
    public int getThroughput() {
        return (int) objectives[1];
    }

    @Override
    public SimulationState getState() {
        return null;
    }

    @Override
    public void setSpawnVehicles(boolean spawnVehicles) {

    }

    @Override
    public void setAsMainSimulator(boolean headless) {

    }

    @Override
    public double getSimulationTime() {
        return 0;
    }

    @Override
    public double getTotalDistanceTraveledInLastTimeStep() {
        return 0;
    }

    @Override
    public double getKineticEnergyLostInLastTimeStep() {
        return 0;
    }

    @Override
    public double getCarsEvacuatedFromInnerIntersectionInLastTimeStep() {
        return 0;
    }

    @Override
    public double getStoppageTimeOfStoppedCars() {
        return 0;
    }

    private double evaluateCollisions(double[] solution) {
        return -evaluateThroughput(solution);
    }

    private double evaluateThroughput(double[] solution) {
        double objective1 = 0;
        for (double aSolution : solution) {
            objective1 += aSolution;
        }
        return -objective1;
    }

    @Override
    public int getNumberOfActiveCars() {
        return 0;
    }

    /**
     * Do a step in the simulation with the provided speeds. This method has the environment already set.
     * @param speeds
     */
    @Override
    public void step(double[] speeds) {

    }
}
