package jossihawk.simulator.sim;

import jossihawk.simulator.SimulationState;

import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import java.util.Arrays;

@XmlRootElement
public class MOEASimulationState implements Comparable<MOEASimulationState>{

    @XmlElement
    private SimulationState state;
    @XmlElement
    private double[] speedVector;
    @XmlElement
    private double simulationTime;

    public MOEASimulationState(){}

    public MOEASimulationState(SimulationState state, double[] speedVector, double simulationTime) {
        this.state = state;
        this.speedVector = speedVector;
        this.simulationTime = simulationTime;
    }

    public int compareTo(MOEASimulationState o) {
        if(this.simulationTime > o.simulationTime)
            return 1;
        return -1;
    }

    public SimulationState getState() {
        return state;
    }

    public double[] getSpeedVector() {
        return speedVector;
    }

    public double getSimulationTime() {
        return simulationTime;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof MOEASimulationState)) return false;

        MOEASimulationState that = (MOEASimulationState) o;

        if (Double.compare(that.simulationTime, simulationTime) != 0) return false;
        if (state != null ? !state.equals(that.state) : that.state != null) return false;
        return Arrays.equals(speedVector, that.speedVector);

    }

    @Override
    public int hashCode() {
        int result;
        long temp;
        result = state != null ? state.hashCode() : 0;
        result = 31 * result + (speedVector != null ? Arrays.hashCode(speedVector) : 0);
        temp = Double.doubleToLongBits(simulationTime);
        result = 31 * result + (int) (temp ^ (temp >>> 32));
        return result;
    }
}
