package jossihawk.simulator.sim;

import aim4.vehicle.VehicleSimView;

import java.util.HashSet;
import java.util.Set;

/**
 * A simple VIN registry. Necessary because the AIM4 version requires vehicles spawned from a spawn point,
 * and is shared statically across simulators.
 */
public class ThreadSafeVinRegistry {
    int counter = 1000;
    Set<Integer> usedVins = new HashSet<Integer>();

    public synchronized void registerVehicle(VehicleSimView vehicle){
        while (usedVins.contains(counter)) counter++;
        usedVins.add(counter);
        vehicle.setVIN(counter++);
    }

    public synchronized void registerVehicleWithGivenVin(VehicleSimView vehicle){
        if(!usedVins.contains(vehicle.getVIN())){
            usedVins.add(vehicle.getVIN());
        }else{
            throw new RuntimeException("This VIN has already been registered. Is he simulator occupied already?");
        }
    }
}
