package jossihawk.simulator.sim;

public class VehicleState{

    public int startLane, endLane;
    public double heading;
    public double steeringAngle;
    public double velocity;
    public double acceleration;
    public int VIN;
    public double x;
    public double y;
    public String carType;

    public VehicleState(){}


    public VehicleState(int startLane, int endLane, double heading, double steeringAngle, double velocity, double acceleration, int VIN, double x, double y, String carType) {
        this.startLane = startLane;
        this.endLane = endLane;
        this.heading = heading;
        this.steeringAngle = steeringAngle;
        this.velocity = velocity;
        this.acceleration = acceleration;
        this.VIN = VIN;
        this.x = x;
        this.y = y;
        this.carType = carType;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof VehicleState)) return false;

        VehicleState that = (VehicleState) o;

        if (startLane != that.startLane) return false;
        if (endLane != that.endLane) return false;
        if (Double.compare(that.heading, heading) != 0) return false;
        if (Double.compare(that.steeringAngle, steeringAngle) != 0) return false;
        if (Double.compare(that.velocity, velocity) != 0) return false;
        if (Double.compare(that.acceleration, acceleration) != 0) return false;
        if (VIN != that.VIN) return false;
        if (Double.compare(that.x, x) != 0) return false;
        if (Double.compare(that.y, y) != 0) return false;
        return carType.equals(that.carType);

    }

    @Override
    public int hashCode() {
        int result;
        long temp;
        result = startLane;
        result = 31 * result + endLane;
        temp = Double.doubleToLongBits(heading);
        result = 31 * result + (int) (temp ^ (temp >>> 32));
        temp = Double.doubleToLongBits(steeringAngle);
        result = 31 * result + (int) (temp ^ (temp >>> 32));
        temp = Double.doubleToLongBits(velocity);
        result = 31 * result + (int) (temp ^ (temp >>> 32));
        temp = Double.doubleToLongBits(acceleration);
        result = 31 * result + (int) (temp ^ (temp >>> 32));
        result = 31 * result + VIN;
        temp = Double.doubleToLongBits(x);
        result = 31 * result + (int) (temp ^ (temp >>> 32));
        temp = Double.doubleToLongBits(y);
        result = 31 * result + (int) (temp ^ (temp >>> 32));
        result = 31 * result + carType.hashCode();
        return result;
    }
}
