package jossihawk.simulator.sim.playback;

import jossihawk.simulator.sim.MOEASimulationState;
import org.moeaframework.util.io.FileUtils;

import javax.xml.bind.JAXBException;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;

public class ScenarioStorer {
    private final File simulationPlaybackFolder;
    private final File playbackFile;


    public static transient final String replayFolder = "scenarios/";

    static {
        File folder = new File(replayFolder);
        makeSureFolderExists(folder);
    }

    private static void makeSureFolderExists(File folder){
        if(!(folder.exists()))
            folder.mkdir();
    }

    public ScenarioStorer(int numOfCars, double spawnRateSouth, double spawnRateNorth, double spawnRateEast, double spawnRateWest) throws IOException {
        simulationPlaybackFolder = new File(replayFolder + numOfCars + "-" + spawnRateNorth + "-" + spawnRateSouth + "-" + spawnRateEast + "-" + spawnRateWest + "-" + System.currentTimeMillis());
        makeSureFolderExists(simulationPlaybackFolder);
        FileUtils.copy(new File("test.properties"), new File(simulationPlaybackFolder, "test.properties"));
        playbackFile = new File(simulationPlaybackFolder, "state.xml");
    }

    public void recordSimulationPlayback(SimulationPlayback playback) throws JAXBException {
        playback.writeToFile(playbackFile);
    }

    public static MOEASimulationState getStateFromFile(File file) throws FileNotFoundException, JAXBException {
        SimulationPlayback playback = SimulationPlayback.readFromFile(file);
        return playback.getStates().get(playback.getStates().size() - 1);
    }

    public File getPlaybackFile() {
        return playbackFile;
    }
}
