package jossihawk.simulator.sim.playback;

import javax.xml.bind.JAXBException;
import java.io.File;
import java.io.IOException;

public class SimulationRecordingKeeper {
    private final File simulationPlaybackFolder;
    private final File playbackFile;


    public static transient final String replayFolder = "playbacks/";

    static {
        File folder = new File(replayFolder);
        makeSureFolderExists(folder);
    }

    private static void makeSureFolderExists(File folder){
        if(!(folder.exists()))
            folder.mkdir();
    }

    public SimulationRecordingKeeper(boolean isImportant, String title) throws IOException {
        simulationPlaybackFolder = new File(replayFolder + (isImportant ? "imp-" : "not-") + title + "-" + System.currentTimeMillis());
        makeSureFolderExists(simulationPlaybackFolder);
//        FileUtils.copy(new File("test.properties"), new File(simulationPlaybackFolder, "test.properties"));
        playbackFile = new File(simulationPlaybackFolder, "playback.xml");
    }

    public void recordSimulationPlayback(SimulationPlayback playback) throws JAXBException {
        playback.writeToFile(playbackFile);
    }

    public void recordSimulationPlayback(SimulationPlayback playback, File storageFile) throws JAXBException {
        playback.writeToFile(storageFile);
    }

    public File getPlaybackFile() {
        return playbackFile;
    }
}
