package jossihawk.simulator.sim.stats;

import jossihawk.simulator.sim.MOEASimulator;
import jossihawk.simulator.sim.VehicleState;

import java.util.HashSet;
import java.util.Set;

public class StatCounter extends SmallScaleStatisticsEventListener {

    private Set<VehicleTimeEvent> vehiclesCrashed = new HashSet<>();
    private Set<VehicleTimeEvent> vehiclesSpawned = new HashSet<>();
    private Set<VehicleTimeEvent> vehiclesRemoved = new HashSet<>();

    public StatCounter(MOEASimulator simulator) {
        super(simulator);
    }


    public void vehicleSpawned(double timeStep, int vin) {
        vehiclesSpawned.add(new VehicleTimeEvent(vin, timeStep));
    }

    public void vehicleRemoved(double timeStep, int vin) {
        vehiclesRemoved.add(new VehicleTimeEvent(vin, timeStep));
    }

    public void vehicleMoved(double timeStep, VehicleState stateBefore, VehicleState stateAfter) {
        // currently no need to look at movement in the internal simulator, as Ek is handled one step up
    }

    public void vehiclesCollide(double timeStep, VehicleState vehicle1, VehicleState vehicle2) {
        vehiclesCrashed.add(new VehicleTimeEvent(vehicle1.VIN, timeStep));
        vehiclesCrashed.add(new VehicleTimeEvent(vehicle2.VIN, timeStep));
    }



}
