package jossihawk.simulator.sim.stats;

public class VehicleTimeEvent {
    public final int vin;
    public final double timeStep;

    public VehicleTimeEvent(int vin, double timeStep) {
        this.vin = vin;
        this.timeStep = timeStep;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof VehicleTimeEvent)) return false;

        VehicleTimeEvent that = (VehicleTimeEvent) o;

        if (vin != that.vin) return false;
        return Double.compare(that.timeStep, timeStep) == 0;

    }

    @Override
    public int hashCode() {
        int result;
        long temp;
        result = vin;
        temp = Double.doubleToLongBits(timeStep);
        result = 31 * result + (int) (temp ^ (temp >>> 32));
        return result;
    }
}
