package jossihawk.utils;

import java.util.ArrayList;
import java.util.List;

public class AvgExperimentFourResult {
    private final double spawnRate;
    private List<Double> metList = new ArrayList<>();
    private List<Double> chrashList = new ArrayList<>();
    private List<Double> throughputList = new ArrayList<>();
    private List<Double> ekList = new ArrayList<>();

    public AvgExperimentFourResult(double spawnRate) {
        this.spawnRate = spawnRate;
        metList = new ArrayList<>();
        chrashList = new ArrayList<>();
        throughputList = new ArrayList<>();
        ekList = new ArrayList<>();
    }

    public void addMET(double meanEvacTime) {
        metList.add(meanEvacTime);
    }

    public void addChrashes(int nofChrashedVehicles) {
        chrashList.add((double) nofChrashedVehicles);
    }

    public void addThroughput(int throughput) {
        throughputList.add((double) throughput);
    }

    public void addEk(double totalSpentEk) {
        ekList.add(totalSpentEk);
    }

    private double avg(List<Double> vals) {
        return vals.stream().mapToDouble(i -> i).average().getAsDouble();
    }

    public double getAvgMet() {
        return avg(metList);
    }

    public double getAvgChrash() {
        return avg(chrashList);
    }

    public double getAvgThroughput() {
        return avg(throughputList);
    }

    public double getAvgEk() {
        return avg(ekList);
    }
    public double getSpawn() {
        double[] spawnRates = {
                0.1053383170998845,
                0.22304399484793236,
                0.3564206308646345,
                0.5103040934054393,
                0.6921871619826325,
                0.9146136040714126,
                1.2010783516194223,
                1.6042684308743838,
                2.2920137768080995,
                250.0};
        double returnRate = 0.0;
        for (int i = 0; i < spawnRates.length; i++) {
            double rate = spawnRates[i];
            if(spawnRate == rate)
                returnRate = (i+1)/10.0;
        }
        return returnRate;
    }

    public int getNofChrashed() {
        int chrashed = 0;
        for (Double chrash : chrashList) {
            if (chrash > 0) {
                chrashed++;
            }
        }
        return chrashed;
    }

    public int size() {
        return chrashList.size();
    }

    public double getPercentChrash() {
        return 100* getNofChrashed()/(double)size();
    }
}
