package jossihawk.utils;

import jossihawk.simulator.SimulationProperties;
import jossihawk.simulator.SimulationState;
import jossihawk.simulator.sim.SimulatorController;

public class CarSpawnStats {

    public static double[] getArray(int length, double value){
        double[] result = new double[length];
        for (int i = 0; i < result.length; i++) {
            result[i] = value;
        }
        return result;
    }

    public static int count(double sr, double time){
        SimulationProperties props = new SimulationProperties("spawnMeasure.properties");
        props.setSpawnRateEast(sr);
        props.setSpawnRateNorth(sr);
        props.setSpawnRateWest(sr);
        props.setSpawnRateSouth(sr);
        SimulatorController controller = new SimulatorController(new SimulationState(null, props));
        controller.setAsMainSimulator(true);
        controller.setSpawnVehicles(true);
        for (int i = 0; i < time / props.getAlgorithmTimeStepSize(); i++){
            controller.step(getArray(controller.getNumberOfActiveCars(), 25.0));
        }
//        System.out.println(controller.getTotalStats().getMeanEvacTime());
//        System.out.println(controller.getTotalStats().getTotalSpentEk());
        return controller.getTotalStats().getThroughput() + controller.getNumberOfActiveCars();
    }

    public static void main(String[] args) {
        double time = 3600;
        double[] spawnRates = {
                0.1053383170998845,
                0.22304399484793236,
                0.3564206308646345,
                0.5103040934054393,
                0.6921871619826325,
                0.9146136040714126,
                1.2010783516194223,
                1.6042684308743838,
                2.2920137768080995,
                250.0};
        System.out.println("\\textbf{Spawn rate} \t& $\\frac{vehicles}{hour}$ \\\\ \\hline");
        for (int i = 0; i < spawnRates.length; i++) {
            System.out.printf("%2.1f \t\t& %f \t\t \\\\ \\hline \n",(i + 1) / 10.0, count(spawnRates[i], time) * 3600d / time);

        }
    }
}
