package jossihawk.utils;

import org.moeaframework.util.io.FileUtils;

import java.io.File;
import java.io.IOException;

public class ExperimentMultiplier {

    private final File setupDir;

    public ExperimentMultiplier(File setupDir) {
        this.setupDir = setupDir;
    }

    public void multiplyExperimentTwo(String fileName, String destinationDirName , int multiplier) throws IOException {
        File destinationExperiment = new File(setupDir, destinationDirName);
        if(destinationExperiment.exists())
            throw new RuntimeException("Destination already exists");
        else destinationExperiment.mkdir();
        File sourceExperiment = new File(setupDir, fileName);
        File[] runs = sourceExperiment.listFiles();
        for (int i = 1; i < multiplier+1; i++) {
            for (int j = 0; j < runs.length; j++) {
                File run = runs[j];
                String newName = createNewName(run.getName(), i);
                File newRun = new File(destinationExperiment, newName);
                newRun.mkdir();
                FileUtils.copy(new File(run, run.getName()+ ".properties"),new File(newRun, newRun.getName() + ".properties"));
            }
        }
    }

    private String createNewName(String name, int copyNum) {
        String[] split = name.split("-");
        String newstring = Integer.toString(copyNum);
        for (int i = 1; i < split.length; i++) {
            newstring += "-" + split[i];
        }
        return newstring;
    }

    public static void main(String[] args) throws IOException {
        ExperimentMultiplier experimentMultiplier = new ExperimentMultiplier(new File("setups"));
        experimentMultiplier.multiplyExperimentTwo("ex2fixed_collisions","ex2fixed_collisions_significant", 15);
    }

}
