package jossihawk;

import jossihawk.simulator.AIMStats;
import jossihawk.simulator.sim.stats.VehicleStatistics;
import org.junit.Assert;
import org.junit.Test;

import javax.xml.bind.JAXBException;
import java.io.File;
import java.io.FileNotFoundException;
import java.util.HashMap;
import java.util.Map;

/**
 * Created by jostein on 15.04.2016.
 */


public class AIMStatsTest {

    @Test
    public void testWriteAndReadFromFile() {
        Map<Integer, VehicleStatistics> vehicleStatisticsMap = new HashMap<>();
        for (int i = 0; i < 3; i++) {
            vehicleStatisticsMap.put(i, new VehicleStatistics(i,i,i));
        }
        AIMStats aimStats = new AIMStats(vehicleStatisticsMap, 5);
        try {
            String filePath = "testAimstats";
            aimStats.writeToFile(new File(filePath));
            AIMStats readAimstats = AIMStats.readFromFile(new File(filePath));
            Assert.assertEquals(readAimstats.toString(), aimStats.toString());
            new File(filePath).delete();
        } catch (JAXBException e) {
            e.printStackTrace();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
    }
}
