package jossihawk;

import jossihawk.simulator.SimulationProperties;
import jossihawk.simulator.SimulationState;
import jossihawk.simulator.sim.MOEASimulationState;
import jossihawk.simulator.sim.playback.SimulationPlayback;
import jossihawk.simulator.sim.SimulatorController;
import jossihawk.simulator.sim.playback.SimulationRecordingKeeper;
import org.junit.Assert;
import org.junit.Test;

import javax.xml.bind.JAXBException;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;

/**
 * Created by haakondi on 04.03.2016.
 */
public class SimulationPlaybackTest {


    @Test
    public void testSerializationDeserializationSameObjectBeforeAndAfter() throws JAXBException, IOException {
        SimulatorController controller = new SimulatorController(new SimulationState(null, new SimulationProperties("test.properties")));
        SimulationPlayback playback = new SimulationPlayback();
        double[] speeds = {1,2,3};

        controller.getSimulator().setSpawnVehicles(true);

        while (controller.getSimulator().getActiveVehicles().size() < 2) {
            controller.getSimulator().step(20);
        }

        MOEASimulationState state = new MOEASimulationState(controller.getState(),speeds, 2.0 );
        playback.addState(state);

        controller.getSimulator().step(100);
        state = new MOEASimulationState(controller.getState(),speeds, 2.0 );
        playback.addState(state);

        SimulationRecordingKeeper keeper = new SimulationRecordingKeeper(false, "test");
        keeper.recordSimulationPlayback(playback);

        SimulationPlayback playback2 = SimulationPlayback.readFromFile(keeper.getPlaybackFile());

        Assert.assertTrue(playback.equals(playback2));
    }
}
